# IRsUnknownBone Interface Reference

Inherits IUnknown.

List of all members.

## Public Member Functions
HRESULT | InvalidateJoints ()
HRESULT | UpdateJoints ()
HRESULT | GetAdjacentJointsCount ([out, retval] RtUlong *pCount)
HRESULT | GetAdjacentJoint ([in] RtUlong dwIndex,[out, retval] IRsNode **pNode)
HRESULT | GetRootJoint ([out, retval] IRsNode **pNode)
HRESULT | SetTransform ([in] IRdMatrixf *pTransform)
HRESULT | GetSkinTransform ([in] RtMatrixf *pTransform)
HRESULT | SetSkinTransform ([in] RtMatrixf *pTransform)
HRESULT | InvalidateFkPose ()
HRESULT | GetSkeletonNode ([out, retval] IRsNode **ppSkeletonNode)
HRESULT | GetBoneId ([out, retval] GUID *pBoneId)
HRESULT | SetBoneId ([in] GUID *pBoneId)

## Detailed Description

IRsUnknownBone is an interface to Skeleton bone.

## Member Function Documentation

HRESULT IRsUnknownBone::InvalidateJoints | ( |  | ) |

Invalidate joints structure. Call whenever topology of adjacent joints changes.

Returns:
  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::UpdateJoints | ( |  | ) |

Update joints structure. Call before accessing adjacent joints array.

Returns:
  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::GetAdjacentJointsCount | ( | [out, retval] RtUlong * | pCount | ) |

Get number of adjacent joints.

Returns:
  pCount [out,retval] Returned number of adjacent joints.

  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::GetAdjacentJoint | ( | [in] RtUlong | dwIndex,
|  | [out, retval] IRsNode ** | pNode |
| ) |  |  |

Get adjacent joint.

Parameters:

  | dwIndex | [in] Index value of joint.

Returns:
  pNode [out,retval] .

  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::GetRootJoint | ( | [out, retval] IRsNode ** | pNode | ) |

Get root joint.

Returns:
  pNode [out,retval] Returns root joint.

  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::SetTransform | ( | [in] IRdMatrixf * | pTransform | ) |

Set bone transform matrix without causing invalidations.

Parameters:

  | pTransform | [in] Interface to transform matrix to set.

Returns:
  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::GetSkinTransform | ( | [in] RtMatrixf * | pTransform | ) |

Get internal skin transform matrix.

Parameters:

  | pTransform | [in] Pointer to transform matrix to be filled with reference matrix.

Returns:
  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::SetSkinTransform | ( | [in] RtMatrixf * | pTransform | ) |

Set internal skin transform matrix.

Parameters:

  | pTransform | [in] Pointer to transform matrix to be filled with reference matrix.

Returns:
  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::InvalidateFkPose | ( |  | ) |

Invalidate FK pose so that values are recalculated on next getvalue.

Returns:
  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::GetSkeletonNode | ( | [out, retval] IRsNode ** | ppSkeletonNode | ) |

Get skeleton node.

Returns:
  ppSkeletonNode [out,retval] Returns skeleton node.

  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::GetBoneId | ( | [out, retval] GUID * | pBoneId | ) |

Get bone ID.

Returns:
  pBoneId [out,retval] Id of bone.

  standard HRESULT processing can be applied to returned value.

HRESULT IRsUnknownBone::SetBoneId | ( | [in] GUID * | pBoneId | ) |

Set bone ID.

Parameters:

  | pBoneId | [in] Sets ID for bone.

Returns:
  standard HRESULT processing can be applied to returned value